<template>
    <div class="animated_text">
        {{ wonderCurrent }}
    </div>
</template>

<script>
export default {
    props: {
        wonders: {
            required: true
        }
    },
    data() {
        return {
            wonderCurrent: "",
            wonderCurrentId: 0,
            wonderCurrentCharacterId: 0,
            fillupTimeout: null,
        }
    },
    mounted() {
        this.fillUpWonderCurrent()
    },
    methods: {
        randomInt(min, max) {
	        return min + Math.floor((max - min) * Math.random());
        },
        fillUpWonderCurrent() {
            this.addCharacterToCurrentWonder()
        },
        addCharacterToCurrentWonder () {
            if (this.wonderCurrentCharacterId < this.wonders[this.wonderCurrentId].length) {
                this.wonderCurrent += this.wonders[this.wonderCurrentId][this.wonderCurrentCharacterId];
                this.wonderCurrentCharacterId++;
                setTimeout(this.addCharacterToCurrentWonder, this.randomInt(50, 200))
            } else {
                setTimeout(this.nextWonder, this.randomInt(700, 1200))
            }
        },
        nextWonder () {
            this.wonderCurrentCharacterId = 0;
            this.wonderCurrentId++;
            if (this.wonderCurrentId == this.wonders.length) {
                this.wonderCurrentId = 0
            }
            this.removeCharacterFromCurrentWonder()
        },
        removeCharacterFromCurrentWonder () {
            this.wonderCurrent = this.wonderCurrent.substring(0, this.wonderCurrent.length - 1);
            if (this.wonderCurrent != "") {
                setTimeout(this.removeCharacterFromCurrentWonder, this.randomInt(50, 100))
            } else {
                setTimeout(this.addCharacterToCurrentWonder, this.randomInt(700, 1200))
            }
        }
    }
}
</script>

<style>

</style>